<template lang="html">
  <v-touch @swipeleft="activateSecondLevel('left')"
    @swiperight="activateSecondLevel('right')"
    :class="['er-swipe-area', {'second-level-active': isSecondLeveActive}]">
    <nav :class="[position, size, {static: static}]"
      class="er-side-menu-container">
      <div class="er-side-menu-top-level-items">
        <slot name="top-level">
        </slot>
      </div>
      <div class="er-side-menu-second-level-items"
        :class="{active: isSecondLeveActive}">
        <slot name="second-level">
        </slot>
      </div>
    </nav>
  </v-touch>
</template>

<script>
export default {
  name: 'SideMenuContainer',
  props: {
    position: {
      validator (value) {
        return ['left', 'right', 'top', 'bottom'].indexOf(value) !== -1
      },
      default: 'left'
    },
    static: {
      type: Boolean,
      default: false
    },
    size: {
      validator (value) {
        return ['small'].indexOf(value) !== -1
      },
      default: null
    }
  },
  data () {
    return {
      isSecondLeveActive: false
    }
  },
  watch: {
    isSecondLeveActive (value) {
      let body = document.body
      value ? body.classList.add('er-side-menu-second-active') : body.classList.remove('er-side-menu-second-active')
    }
  },
  created () {
    let body = document.body
    body.classList.add(`er-side-menu-${this.position}`)
    !this.size ? '' : body.classList.add(`er-side-menu-${this.size}`)
  },
  methods: {
    activateSecondLevel (direction) {
      let directions = {
        left: 'right',
        right: 'left'
      }

      if (directions.hasOwnProperty(this.position)) {
        this.isSecondLeveActive = directions[this.position] === direction
      }
    }
  }
}
</script>

<style lang="scss">
@import '../style/base';

.er-side-menu-container {
  position: fixed;
  z-index: 500;
  display: flex;

  &.left, &.right {
    & > .er-side-menu-top-level-items {
      display: flex;
      flex-direction: column;
      width: 85px;
    }

    & > .er-side-menu-second-level-items {
      width: 235px;
    }
    &.small {
      & > .er-side-menu-top-level-items {
        font-size: .6rem;
        width: 50px;
      }
      & > .er-side-menu-second-level-items {
        width: 180px;
      }
    }
  }
  &.top, &.bottom {
    & > .er-side-menu-top-level-items {
      display: flex;
      flex-direction: row;
      height: 85px;
    }
    & > .er-side-menu-second-level-items {
      min-height: 120px;
    }
    &.small {
      & > .er-side-menu-top-level-items {
        font-size: .6rem;
        height: 50px;
      }
      & > .er-side-menu-second-level-items {
        min-height: 120px;
      }
    }
  }

  & > .er-side-menu-top-level-items {
    position: relative;
    z-index: 510;
    background: $color-bg-top-level;
    box-shadow: $material-shadow-6dp;
  }

  & > .er-side-menu-second-level-items {
    position: relative;
    background: $color-bg-second-level;
    box-shadow: $material-shadow-4dp;
    overflow: hidden;
    transition: all .2s ease-in-out;
  }

  &.left {
    left: 0;
    top: 0;
    bottom: 0;
    flex-direction: row;

    & > .er-side-menu-second-level-items:not(.active) {
      margin-left: -100%;
      @media #{$small-above} {
        & {
          margin-left: 0;
        }
      }
    }
  }

  &.right {
    right: 0;
    top: 0;
    bottom: 0;
    flex-direction: row-reverse;

    & > .er-side-menu-second-level-items:not(.active) {
      margin-right: -100%;

      @media #{$small-above} {
        & {
          margin-right: 0;
        }
      }
    }
  }

  &.top {
    top: 0;
    left: 0;
    right: 0;
    flex-direction: column;
  }

  &.top.static, &.bottom.static {
    position: relative;
  }

  &.bottom {
    bottom: 0;
    left: 0;
    right: 0;
    flex-direction: column-reverse;
  }

}
</style>
